property pSystemId, pSystemThread, pModules

on construct me
pSystemId = "gamesystem"
pModules = ["baselogic", "messagesender", "messagehandler", "procmanager", "turnmanager", "world", "component"]
dumpVariableField("gamesystem.variable.index")
registerMessage(#gamesystem_getfacade, me.getID(), #getFacade)
registerMessage(#gamesystem_removefacade, me.getID(), #removeFacade)
return(1)
end

on deconstruct me
unregisterMessage(#gamesystem_getfacade, me.getID())
unregisterMessage(#gamesystem_removefacade, me.getID())
me.removeGamesystem()
return(1)
end

on getFacade me, tID
if not objectp(pSystemThread) then -- jump 11
me.createGamesystem(tID)
end if -- jump 11 landing
if getObject(tID)  = 0 then -- jump 43
createObject(tID, getClassVariable("gamesystem.facade.class"))
if getObject(tID)  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
getObject(tID).defineClient(pSystemThread)
end if -- jump 43 landing
return(getObject(tID))
end

on removeFacade me, tID
if getObject(tID)  = 0 then -- jump 11
return(0)
 -- jump 19
end if -- jump 11 landing
if removeObject(tID)  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
end if -- jump 19 landing
me.removeGamesystem()
return(1)
end

on createGamesystem me, tSystemId
pSystemThread = createObject(#temp, getClassVariable(pSystemId & ".subsystem.superclass"))
pSystemThread.setaProp(#systemid, tSystemId)
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pModules) <= 1 then -- jump 120 -- backjump 123 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tModule = --nil--
tObjID = symbol(pSystemId & "_" & tModule)
tClassVarName = pSystemId & "." & tModule & ".class"
tClass = getClassVariable(tClassVarName)
if not getmemnum(tClass) then -- jump 20
return(error(me, "Game system class not found!:" && tClassVarName, #createGamesystem))
end if -- jump 20 landing
createObject(tObjID, tClass)
tObj = getObject(tObjID)
tObj[#ancestor] = pSystemThread
pSystemThread.setaProp(symbol(tModule), tObj)
--nil-- + 1
 -- backjump 123
end if -- jump 120 landing
 --TRIMFROMSTACK 3 
tModuleObj = createObject(symbol(pSystemId & "_variablemanager"), getClassVariable("variable.manager.class"))
pSystemThread.setaProp(#variablemanager, tModuleObj)
executeMessage(#gamesystem_constructed)
return(1)
end

on removeGamesystem me
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pModules) <= 1 then -- jump 38 -- backjump 41 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tModule = --nil--
tObjID = symbol(pSystemId & "_" & tModule)
removeObject(tObjID)
--nil-- + 1
 -- backjump 41
end if -- jump 38 landing
 --TRIMFROMSTACK 3 
removeObject(symbol(pSystemId & "_variablemanager"))
pSystemThread = void()
executeMessage(#gamesystem_deconstructed)
return(1)
end
