property pProcessorObjList, pUpdateBrokerList, pBaseProcClassList

on construct me
pProcessorObjList = [:]
pUpdateBrokerList = [:]
if not variableExists("gamesystem.processor.superclass") then -- jump 18
return(error(me, "gamesystem.processor.superclass not found.", #defineProcessors))
end if -- jump 18 landing
pBaseProcClassList = getClassVariable("gamesystem.processor.superclass")
return(1)
end

on deconstruct me
me.removeAllProcessors()
return(1)
end

on defineClient me, tID
return(me.defineProcessors())
end

on distributeEvent me, tTopic, tdata
tBaseLogic = me.getBaseLogic()
tStoreMethod = symbol("store_" & tTopic)
if tBaseLogic.handler(tStoreMethod) then -- jump 14
call(tStoreMethod, tBaseLogic, tdata)
end if -- jump 14 landing
if not pUpdateBrokerList.findPos(tTopic) then -- jump 8
return(0)
end if -- jump 8 landing
tList = pUpdateBrokerList.getProp(tTopic)
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tList) <= 1 then -- jump 75 -- backjump 78 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tListenerId = --nil--
tListener = pProcessorObjList.getaProp(tListenerId)
if tListener <> void() then -- jump 20
call(#handleUpdate, tListener, tTopic, tdata)
 -- jump 21
end if -- jump 20 landing
pProcessorObjList.deleteProp(tListenerId)
tList.deleteOne(tListenerId)
end if -- jump 21 landing
--nil-- + 1
 -- backjump 78
end if -- jump 75 landing
 --TRIMFROMSTACK 3 
return(1)
end

on defineProcessors me
me.removeAllProcessors()
tID = me.getSystemId()
if variableExists(tID & ".processors") then -- jump 15
tProcIdList = getVariableValue(tID & ".processors")
end if -- jump 15 landing
if not listp(tProcIdList) then -- jump 21
return(error(me, "Processor list not found:" && tID, #defineProcessors))
end if -- jump 21 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tProcIdList) <= 1 then -- jump 27 -- backjump 30 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tProcId = --nil--
me.defineSingleProcessor(tProcId)
--nil-- + 1
 -- backjump 30
end if -- jump 27 landing
 --TRIMFROMSTACK 3 
return(1)
end

on defineSingleProcessor me, tProcId
tID = me.getSystemId()
tProcObjId = symbol(tID & "_proc_" & tProcId)
tScriptList = getClassVariable(tID & "." & tProcId & ".processor.class")
if not listp(tScriptList) then -- jump 27
return(error(me, "Script list not found:" && tID & "." & tProcId, #defineProcessors))
end if -- jump 27 landing
tScriptList.addAt(1, pBaseProcClassList)
tProcObject = createObject(tProcObjId, tScriptList)
if not objectp(tProcObject) then -- jump 30
return(error(me, "Unable to create processor object:" && tProcObjId && tScriptList && tScriptList.ilk, #defineProcessors))
end if -- jump 30 landing
tProcObject.setaProp(#pFacadeId, tID)
tProcObject.setaProp(#pID, tProcId)
tProcObject.setID(tProcId, tID)
pProcessorObjList.addProp(tProcId, tProcObject)
tProcessorRegList = getVariableValue(tID & "." & tProcId & ".processor.updates")
if listp(tProcessorRegList) then -- jump 135
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tProcessorRegList) <= 1 then -- jump 115 -- backjump 118 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tMsg = --nil--
if tMsg  = void() then -- jump 24
return(error(me, "Invalid format in processor message:" && tProcObjId && tMsg, #defineProcessors))
end if -- jump 24 landing
if voidp(pUpdateBrokerList[tMsg]) then -- jump 15
pUpdateBrokerList.addProp(tMsg, [])
end if -- jump 15 landing
if pUpdateBrokerList[tMsg].getPos(tProcId)  = 0 then -- jump 19
pUpdateBrokerList[tMsg].add(tProcId)
end if -- jump 19 landing
--nil-- + 1
 -- backjump 118
end if -- jump 115 landing
 --TRIMFROMSTACK 3 
end if -- jump 135 landing
return(1)
end

on removeSingleProcessor me, tProcId
tProcObject = pProcessorObjList.getaProp(tProcId)
if not objectp(tProcObject) then -- jump 21
return(error(me, "Processor not found:" && tProcId, #removeSingleProcessor))
end if -- jump 21 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pUpdateBrokerList) <= 1 then -- jump 27 -- backjump 30 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tMsg = --nil--
tMsg.deleteOne(tProcId)
--nil-- + 1
 -- backjump 30
end if -- jump 27 landing
 --TRIMFROMSTACK 3 
tProcObjectId = tProcObject.getID()
pProcessorObjList.deleteProp(tProcId)
removeObject(tProcObjectId)
return(1)
end

on getProcessor me, tProcId
return(pProcessorObjList.getaProp(tProcId))
end

on removeAllProcessors me
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pProcessorObjList) <= 1 then -- jump 28 -- backjump 31 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tProc = --nil--
removeObject(tProc.getID())
--nil-- + 1
 -- backjump 31
end if -- jump 28 landing
 --TRIMFROMSTACK 3 
pProcessorObjList = [:]
pUpdateBrokerList = [:]
return(1)
end
