property pConnectionId, pUpdateInterval

on construct me
pConnectionId = getVariableValue("connection.info.id")
pUpdateInterval = getIntVariable("gamesystem.instancelist.updatetime", 15000)
return(1)
end

on deconstruct me
me.setInstanceListUpdates(0)
return(1)
end

on setInstanceListUpdates me, tBoolean
tTimeoutID = #gamesystem_update
tVarMgrObj = me.getVariableManager()
if not tVarMgrObj.exists(#instancelist_timestamp) then -- jump 12
tVarMgrObj.set(#instancelist_timestamp, 0)
end if -- jump 12 landing
if tBoolean then -- jump 77
if abs(the milliSeconds - tVarMgrObj.GET(#instancelist_timestamp)) > pUpdateInterval then -- jump 13
me.getMessageSender().sendGetInstanceList()
end if -- jump 13 landing
if timeoutExists(tTimeoutID) then -- jump 9
return(1)
end if -- jump 9 landing
return(createTimeout(tTimeoutID, pUpdateInterval, #sendGetInstanceList, me.getID()))
 -- jump 35
end if -- jump 77 landing
tVarMgrObj.set(#instancelist_timestamp, 0)
if timeoutExists(tTimeoutID) then -- jump 10
removeTimeout(tTimeoutID)
end if -- jump 10 landing
return(1)
end if -- jump 35 landing
end

on sendGetInstanceList me
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendGetInstanceList))
end if -- jump 21 landing
me.getVariableManager().set(#game_status, #none)
return(getConnection(pConnectionId).send("GETINSTANCELIST"))
end

on sendObserveInstance me, tID
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendObserveInstance))
end if -- jump 21 landing
return(getConnection(pConnectionId).send("OBSERVEINSTANCE", [#integer: tID]))
end

on sendUnobserveInstance me
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendUnobserveInstance))
end if -- jump 21 landing
me.getVariableManager().set(#observed_instance_data, [:])
me.getVariableManager().set(#game_status, #none)
me.setInstanceListUpdates(1)
return(getConnection(pConnectionId).send("UNOBSERVEINSTANCE"))
end

on sendInitiateCreateGame me, tTeamId
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendInitiateCreateGame))
end if -- jump 21 landing
me.setInstanceListUpdates(0)
me.getVariableManager().set(#game_status, #none)
if tTeamId <> void() then -- jump 45
tTeamId = tTeamId - 1
return(getConnection(pConnectionId).send("INITIATECREATEGAME", [#integer: integer(tTeamId)]))
 -- jump 22
end if -- jump 45 landing
return(getConnection(pConnectionId).send("INITIATECREATEGAME"))
end if -- jump 22 landing
end

on sendGameParameterValues me, tParamList, tTeamId
if me.getBaseLogic().getGamestatus()  = #create_requested then -- jump 8
return(0)
end if -- jump 8 landing
tTeamId = tTeamId - 1
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendGameParameterValues))
end if -- jump 21 landing
me.setInstanceListUpdates(0)
tStruct = me.getVariableManager().GET(#gameparametervalues_format)
tCount = tStruct.count
tOutput = [#integer: tCount]
i = 1
if i <= tCount then -- jump 166 -- backjump 169 landing
tValueData = tStruct[i]
if tParamList.findPos(tValueData[#name])  = 0 then -- jump 17
return(error(me, "Invalid game parameter values!", #sendGameParameterValues))
end if -- jump 17 landing
tValue = tParamList[tValueData[#name]]
tOutput.addProp(#string, tValueData[#name])
if tValueData[#type]  = #integer then -- jump 27
tOutput.addProp(#integer, 0)
tOutput.addProp(#integer, tValue)
 -- jump 42
end if -- jump 27 landing
if tValueData[#type]  = #string then -- jump 28
tOutput.addProp(#integer, 1)
tOutput.addProp(#string, string(tValue))
end if -- jump 28 landing
end if -- jump 42 landing
i = 1 + i
 -- backjump 169
end if -- jump 166 landing
me.getVariableManager().set(#game_status, #create_requested)
tOutput.addProp(#integer, tTeamId)
return(getConnection(pConnectionId).send("GAMEPARAMETERVALUES", tOutput))
end

on sendDeleteGame me
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendDeleteGame))
end if -- jump 21 landing
me.getVariableManager().set(#observed_instance_data, [:])
me.getVariableManager().set(#game_status, #none)
me.setInstanceListUpdates(1)
return(getConnection(pConnectionId).send("DELETEGAME"))
end

on sendInitiateJoinGame me, tInstanceId, tTeamId
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendInitiateJoinGame))
end if -- jump 21 landing
tdata = me.getVariableManager().GET(#observed_instance_data)
if tdata.findPos(#id)  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tInstanceId  = void() then -- jump 13
tInstanceId = tdata[#id]
end if -- jump 13 landing
if tTeamId  = void() then -- jump 8
return(0)
end if -- jump 8 landing
tTeamId = tTeamId - 1
me.setInstanceListUpdates(0)
me.getVariableManager().set(#game_status, #none)
return(getConnection(pConnectionId).send("INITIATEJOINGAME", [#integer: tInstanceId, #integer: tTeamId]))
end

on sendJoinParameterValues me, tInstanceId, tTeamId, tParamList
if me.getBaseLogic().getGamestatus()  = #join_requested then -- jump 8
return(0)
end if -- jump 8 landing
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendJoinParameterValues))
end if -- jump 21 landing
tdata = me.getVariableManager().GET(#observed_instance_data)
if tInstanceId  = void() then -- jump 13
tInstanceId = tdata[#id]
end if -- jump 13 landing
if tInstanceId  = void() then -- jump 8
return(0)
end if -- jump 8 landing
if tTeamId  = void() then -- jump 8
return(0)
end if -- jump 8 landing
tTeamId = tTeamId - 1
tCount = tParamList.count
tOutput = [#integer: tInstanceId, #integer: tTeamId, #integer: tCount]
i = 1
if i <= tCount then -- jump 105 -- backjump 108 landing
tOutput.addProp(#string, tParamList.getPropAt(i))
if ilk(tParamList[i])  = #integer then -- jump 33
tOutput.addProp(#integer, 0)
tOutput.addProp(#integer, tParamList[i])
 -- jump 30
end if -- jump 33 landing
tOutput.addProp(#integer, 1)
tOutput.addProp(#string, tParamList[i])
end if -- jump 30 landing
i = 1 + i
 -- backjump 108
end if -- jump 105 landing
me.setInstanceListUpdates(0)
me.getVariableManager().set(#game_status, #join_requested)
return(getConnection(pConnectionId).send("JOINPARAMETERVALUES", tOutput))
end

on sendLeaveGame me
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendLeaveGame))
end if -- jump 21 landing
me.getVariableManager().set(#game_status, #none)
return(getConnection(pConnectionId).send("LEAVEGAME"))
end

on sendKickPlayer me, tPlayerId
tPlayerId = integer(tPlayerId)
if not integerp(tPlayerId) then -- jump 17
return(error(me, "Integer expected!", #sendKickPlayer))
end if -- jump 17 landing
if not connectionExists(pConnectionId) then -- jump 22
return(error(me, "Connection not found:" && pConnectionId, #sendNavigate))
end if -- jump 22 landing
return(getConnection(pConnectionId).send("KICKPLAYER", [#integer: tPlayerId]))
end

on sendWatchGame me, tInstanceId
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendWatchGame))
end if -- jump 21 landing
me.setInstanceListUpdates(0)
me.getVariableManager().set(#game_status, #watch_requested)
return(getConnection(pConnectionId).send("WATCHGAME", [#integer: tInstanceId]))
end

on sendStartGame me
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendStartGame))
end if -- jump 21 landing
return(getConnection(pConnectionId).send("STARTGAME"))
end

on sendRejoinGame me
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendRejoinGame))
end if -- jump 21 landing
return(getConnection(pConnectionId).send("REJOINGAME"))
end

on sendRequestFullStatusUpdate me
if not connectionExists(pConnectionId) then -- jump 22
return(error(me, "Connection not found:" && pConnectionId, #sendRequestFullStatusUpdate))
end if -- jump 22 landing
return(getConnection(pConnectionId).send("REQUESTFULLSTATUSUPDATE"))
end

on sendGameEventMessage me, tdata
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendGameEventMessage))
end if -- jump 21 landing
if not listp(tdata) then -- jump 17
return(error(me, "Message struct in wrong format", #sendGameEventMessage))
end if -- jump 17 landing
if tdata.getPropAt(1) <> #integer then -- jump 17
return(error(me, "Message struct in wrong format", #sendGameEventMessage))
end if -- jump 17 landing
return(getConnection(pConnectionId).send("MSG_PLAYER_INPUT", tdata))
end

on sendLevelEditorCommand me, tdata
if not connectionExists(pConnectionId) then -- jump 22
return(error(me, "Connection not found:" && pConnectionId, #sendLevelEditorCommand))
end if -- jump 22 landing
if not listp(tdata) then -- jump 18
return(error(me, "Message struct in wrong format", #sendLevelEditorCommand))
end if -- jump 18 landing
if tdata.getPropAt(1) <> #integer then -- jump 18
return(error(me, "Message struct in wrong format", #sendLevelEditorCommand))
end if -- jump 18 landing
return(getConnection(pConnectionId).send("LEVELEDITORCOMMAND", tdata))
end

on sendHabboRoomMove me, tLocX, tLocY
if not connectionExists(pConnectionId) then -- jump 21
return(error(me, "Connection not found:" && pConnectionId, #sendHabboRoomMove))
end if -- jump 21 landing
return(getConnection(pConnectionId).send("MOVE", [#short: tLocX, #short: tLocY]))
end
