property pObjects, pObjectTypeIndex, pObjectGroupIndex, pObjectIdIndex, pCollision, pSquareRoot

on construct me
pGeometry = createObject(#temp, getClassVariable("gamesystem.geometry.class"))
if not objectp(pGeometry) then -- jump 17
return(error(me, "Cannot create pGeometry.", #construct))
end if -- jump 17 landing
pSquareRoot = createObject(#temp, getClassVariable("gamesystem.squareroot.class"))
if not objectp(pSquareRoot) then -- jump 17
return(error(me, "Cannot create pSquareRoot.", #construct))
end if -- jump 17 landing
pCollision = createObject(#temp, getClassVariable("gamesystem.collision.class"))
if not objectp(pCollision) then -- jump 17
return(error(me, "Cannot create pCollision.", #construct))
end if -- jump 17 landing
pCollision.setaProp(#pSquareRoot, pSquareRoot)
pObjects = [:]
pObjectTypeIndex = [:]
pObjectGroupIndex = [:]
pObjectIdIndex = []
initIntVector()
receiveUpdate(me.getID())
return(1)
end

on deconstruct me
removeUpdate(me.getID())
if pObjects.count > 0 then -- jump 25 -- backjump 30 landing
me.removeGameObject(pObjects[1].getObjectId())
 -- backjump 30
end if -- jump 25 landing
pCollision = void()
pSquareRoot = void()
pObjects = void()
pObjectTypeIndex = void()
pObjectGroupIndex = void()
pObjectIdIndex = void()
return(1)
end

on defineClient me, tID
return(1)
end

on getCollision me
return(pCollision)
end

on update me
call(#update, pObjects)
end

on executeGameObjectEvent me, tID, tEvent, tdata
if tID  = #all then -- jump 58
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pObjects) <= 1 then -- jump 31 -- backjump 34 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tGameObject = --nil--
call(#executeGameObjectEvent, tGameObject, tEvent, tdata)
--nil-- + 1
 -- backjump 34
end if -- jump 31 landing
 --TRIMFROMSTACK 3 
return(1)
end if -- jump 58 landing
tGameObject = me.getGameObject(tID)
if tGameObject  = 0 then -- jump 26
return(error(me, "Cannot execute game object event:" && tEvent && "on:" && tID, #executeGameObjectEvent))
end if -- jump 26 landing
call(#executeGameObjectEvent, tGameObject, tEvent, tdata)
return(1)
end

on calculateChecksum me, tSeed
tCheckSum = tSeed
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pObjects) <= 1 then -- jump 30 -- backjump 33 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tObject = --nil--
tCheckSum = tCheckSum + tObject.addChecksum()
--nil-- + 1
 -- backjump 33
end if -- jump 30 landing
 --TRIMFROMSTACK 3 
return(tCheckSum)
end

on dumpChecksumValues me
tText = EMPTY
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pObjects) <= 1 then -- jump 34 -- backjump 37 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tObject = --nil--
tText = tText & tObject.dump(1) & RETURN
--nil-- + 1
 -- backjump 37
end if -- jump 34 landing
 --TRIMFROMSTACK 3 
return(tText)
end

on createGameObject me, tObjectId, ttype, tdata
if not listp(tdata) then -- jump 8
tdata = [:]
end if -- jump 8 landing
tObjectId = integer(tObjectId)
tObjectStrId = string(tObjectId)
if pObjectTypeIndex.getaProp(tObjectId) <> void() then -- jump 20
return(error(me, "Game object by id already exists! Id:" && tObjectId, #createGameObject))
end if -- jump 20 landing
tClass = getClassVariable(me.getSystemId() & "." & ttype & ".class")
tBaseClass = getClassVariable("gamesystem.gameobject.class")
if tClass  = 0 then -- jump 10
tClass = tBaseClass
 -- jump 35
end if -- jump 10 landing
if listp(tClass) then -- jump 17
tClass.addAt(1, tBaseClass)
 -- jump 12
end if -- jump 17 landing
tClass = [tBaseClass, tClass]
end if -- jump 12 landing
end if -- jump 35 landing
tObject = createObject(#temp, tClass)
if tObject  = 0 then -- jump 17
return(error(me, "Unable to create game object!", #createGameObject))
end if -- jump 17 landing
tObject.setID(tObjectStrId)
tObject.setObjectId(tObjectStrId)
tObject.setGameSystemReference(me.getFacade())
pObjects.setaProp(tObjectId, tObject)
pObjects.sort()
pObjectTypeIndex.setaProp(tObjectId, ttype)
pObjectIdIndex.add(tObjectId)
if tdata[#z]  = void() then -- jump 9
tZ = 0
 -- jump 14
end if -- jump 9 landing
tZ = tdata[#z]
end if -- jump 14 landing
tObject.pGameObjectLocation = me.getWorld().initLocation()
tObject.pGameObjectNextTarget = me.getWorld().initLocation()
tObject.pGameObjectFinalTarget = me.getWorld().initLocation()
me.updateGameObject(tObjectStrId, tdata.duplicate())
return(tObject)
end

on updateGameObject me, tObjectId, tdata
tObjectId = string(tObjectId)
tObject = me.getGameObject(tObjectId)
if not listp(tdata) then -- jump 8
return(0)
end if -- jump 8 landing
if tObject  = 0 then -- jump 20
return(error(me, "Game object not found:" && tObjectId, #updateGameObject))
end if -- jump 20 landing
tObject.setGameObjectSyncProperty(tdata)
if tdata[#z]  = void() then -- jump 13
tdata[#z] = 0
end if -- jump 13 landing
if tdata.findPos(#x) > 0 and tdata.findPos(#y) > 0 then -- jump 25
tObject.setLocation(tdata.x, tdata.y, tdata.z)
end if -- jump 25 landing
return(1)
end

on removeGameObject me, tObjectId
tObjectId = integer(tObjectId)
tObjectStrId = string(tObjectId)
ttype = pObjectTypeIndex.getaProp(tObjectId)
if ttype  = void() then -- jump 9
return(1)
end if -- jump 9 landing
pObjectIdIndex.deleteOne(tObjectId)
me.removeGameObjectFromAllGroups(tObjectId)
tObject = me.getGameObject(tObjectStrId)
if objectp(tObject) then -- jump 9
tObject.deconstruct()
end if -- jump 9 landing
pObjects.deleteProp(tObjectId)
pObjectTypeIndex.deleteProp(tObjectId)
return(1)
end

on executeSubturnMoves me, tTurnNum, tSubTurnNum
tRemoveList = []
tCount = pObjects.count
i = 1
if i <= tCount then -- jump 30 -- backjump 33 landing
tGameObject = pObjects[i]
tGameObject.calculateFrameMovement()
i = 1 + i
 -- backjump 33
end if -- jump 30 landing
i = 1
if i <= tCount then -- jump 49 -- backjump 52 landing
tGameObject = pObjects[i]
if tGameObject.getActive()  = 0 then -- jump 17
tRemoveList.add(tGameObject.getObjectId())
end if -- jump 17 landing
i = 1 + i
 -- backjump 52
end if -- jump 49 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tRemoveList) <= 1 then -- jump 26 -- backjump 29 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tObjectId = --nil--
me.removeGameObject(tObjectId)
--nil-- + 1
 -- backjump 29
end if -- jump 26 landing
 --TRIMFROMSTACK 3 
return(1)
end

on getGameObject me, tObjectId
if voidp(pObjects) then -- jump 8
return(0)
end if -- jump 8 landing
return(pObjects.getaProp(integer(tObjectId)))
end

on getGameObjectIdsOfType me, ttype
tResult = []
tCount = pObjectTypeIndex.count
i = 1
if i <= tCount then -- jump 54 -- backjump 57 landing
if pObjectTypeIndex[i]  = ttype or ttype  = #all then -- jump 23
tResult.append(string(pObjectTypeIndex.getPropAt(i)))
end if -- jump 23 landing
i = 1 + i
 -- backjump 57
end if -- jump 54 landing
return(tResult)
end

on getGameObjectType me, tObjectId
tObjectId = integer(tObjectId)
return(pObjectTypeIndex.getaProp(tObjectId))
end

on getAllGameObjectIds me
return(pObjectIdIndex.duplicate())
end

on setGameObjectInGroup me, tGameObjectId, tGroupId
if tGroupId  = void() then -- jump 8
return(0)
end if -- jump 8 landing
if pObjectGroupIndex.findPos(tGroupId)  = 0 then -- jump 15
pObjectGroupIndex.addProp(tGroupId, [])
end if -- jump 15 landing
pObjectGroupIndex.getProp(tGroupId).add(tGameObjectId)
return(1)
end

on removeGameObjectFromAllGroups me, tGameObjectId
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pObjectGroupIndex) <= 1 then -- jump 27 -- backjump 30 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tGroup = --nil--
tGroup.deleteOne(tGameObjectId)
--nil-- + 1
 -- backjump 30
end if -- jump 27 landing
 --TRIMFROMSTACK 3 
return(1)
end

on removeGameObjectFromGroup me, tGameObjectId, tGroupId
if tGroupId  = void() then -- jump 8
return(0)
end if -- jump 8 landing
if pObjectGroupIndex.findPos(tGroupId)  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
pObjectGroupIndex.getProp(tGroupId).deleteOne(tGameObjectId)
return(1)
end

on getGameObjectGroup me, tGroupId
if pObjectGroupIndex.findPos(tGroupId)  = 0 then -- jump 10
return([])
end if -- jump 10 landing
return(pObjectGroupIndex.getaProp(tGroupId).duplicate())
end

on dumpGameObjectGroups me
return(pObjectGroupIndex)
end

on dump me
tText = EMPTY
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pObjects) <= 1 then -- jump 32 -- backjump 35 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tObject = --nil--
tText = tText & tObject.dump() & RETURN
--nil-- + 1
 -- backjump 35
end if -- jump 32 landing
 --TRIMFROMSTACK 3 
return(tText)
end
