property pGeometry, pRoomGeometry, pTileLineOfSight, pWorldReady, pObjectCache, pWorldMaxX, pWorldMaxY, pTileGrid, pTileSpaceReserveList, pTileWidth, pAccuracyFactor, pLocationClass

on construct me
pLocationClass = getClassVariable("gamesystem.location.class")
pRoomGeometry = getThread(#room).getInterface().getGeometry()
pGeometry = createObject(#temp, getClassVariable("gamesystem.geometry.class"))
if not objectp(pGeometry) then -- jump 17
return(error(me, "Cannot create pGeometry.", #construct))
end if -- jump 17 landing
pWorldReady = 0
pTileWidth = 32
pAccuracyFactor = 100
pTileGrid = []
pTileSpaceReserveList = [:]
pObjectCache = [:]
return(1)
end

on deconstruct me
pReady = 0
pTileGrid = void()
pComponentToAngle = void()
pGeometry = void()
pTileLineOfSight = void()
return(1)
end

on storeHeightMapArray me, tdata, tWorldWidth, tWorldHeight, tTileClass
pWorldMaxX = tWorldWidth
pWorldMaxY = tWorldHeight
return(me.createTileGrid(tdata, tTileClass))
end

on storeHeightmap me, tStr, tWorldWidth, tWorldHeight, tTileClass
if voidp(tWorldHeight) then -- jump 18
pWorldMaxY = tStr.count(#line)
 -- jump 8
end if -- jump 18 landing
pWorldMaxY = tWorldHeight
end if -- jump 8 landing
if voidp(tWorldWidth) then -- jump 24
pWorldMaxX = tStr.getPropRef(#line, 1).length
 -- jump 8
end if -- jump 24 landing
pWorldMaxX = tWorldWidth
end if -- jump 8 landing
tdata = []
tLocY = 1
if tLocY <= pWorldMaxY then -- jump 63 -- backjump 67 landing
tLocX = 1
if tLocX <= pWorldMaxX then -- jump 41 -- backjump 45 landing
tdata.append(tStr.getPropRef(#line, tLocY).getProp(#char, tLocX))
tLocX = 1 + tLocX
 -- backjump 45
end if -- jump 41 landing
tLocY = 1 + tLocY
 -- backjump 67
end if -- jump 63 landing
return(me.createTileGrid(tdata, tTileClass))
end

on createTileGrid me, tdata, tTileClass
pTileGrid = []
if tTileClass  = void() then -- jump 8
tTileClass = []
end if -- jump 8 landing
if tTileClass.ilk <> #list then -- jump 12
tTileClass = list(tTileClass)
end if -- jump 12 landing
tTileClass.addAt(1, getClassVariable("gamesystem.tile.class"))
tFramework = me.getFacade()
tCount = 1
tLocY = 1
if tLocY <= pWorldMaxY then -- jump 146 -- backjump 150 landing
pTileGrid[tLocY] = []
tLocX = 1
if tLocX <= pWorldMaxX then -- jump 112 -- backjump 116 landing
tTile = createObject(#temp, tTileClass)
pTileGrid[tLocY][tLocX] = tTile
tTileLocX = tLocX - 1
tTileLocY = tLocY - 1
tCenterLocX = tTileLocX * pTileWidth * pAccuracyFactor
tCenterLocY = tTileLocY * pTileWidth * pAccuracyFactor
tTile.define(tTileLocX, tTileLocY, tCenterLocX, tCenterLocY, pTileWidth, tdata[tCount], tFramework)
tCount = tCount + 1
tLocX = 1 + tLocX
 -- backjump 116
end if -- jump 112 landing
tLocY = 1 + tLocY
 -- backjump 150
end if -- jump 146 landing
pWorldReady = 1
if pObjectCache.count > 0 then -- jump 13
me.storeObjects(pObjectCache)
end if -- jump 13 landing
me.getProcManager().distributeEvent(#world_ready)
return(1)
end

on storeObjects me, tdata
if pWorldReady  = 0 then -- jump 13
pObjectCache = tdata
return(0)
end if -- jump 13 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tdata) <= 1 then -- jump 143 -- backjump 146 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tItem = --nil--
if tItem[#height]  = 0 then -- jump 57
if not listp(tItem[#dimensions]) then -- jump 16
tItem[#height] = 0
 -- jump 27
end if -- jump 16 landing
tItem[#height] = tItem[#dimensions][2]
end if -- jump 27 landing
end if -- jump 57 landing
if not me.reserveTileForObject(tItem[#x], tItem[#y], tItem[#id], tItem[#height]) then -- jump 14
error(me, "Unable to reserve tile for furniture!", #storeObjects)
end if -- jump 14 landing
--nil-- + 1
 -- backjump 146
end if -- jump 143 landing
 --TRIMFROMSTACK 3 
me.getProcManager().distributeEvent(#objects_ready)
return(1)
end

on initLocation me, tX, tY, tZ
tObject = createObject(#temp, pLocationClass)
if tObject  = 0 then -- jump 18
return(error(me, "Cannot initialize location object.", #initLocation))
end if -- jump 18 landing
tObject.define(tX, tY, tZ, pTileWidth, pAccuracyFactor)
return(tObject)
end

on initLocationAsTile me, tX, tY, tZ
tObject = me.initLocation(tX, tY, tZ)
if tObject  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tObject.setTileLoc(tX, tY, tZ)
return(tObject)
end

on getTile me, tLocX, tLocY
tLocX = tLocX + 1
tLocY = tLocY + 1
if tLocX <= 0 or tLocY <= 0 then -- jump 8
return(0)
end if -- jump 8 landing
if pTileGrid.count < tLocY then -- jump 8
return(0)
end if -- jump 8 landing
tRow = pTileGrid[tLocY]
if tRow.count < tLocX then -- jump 8
return(0)
end if -- jump 8 landing
return(tRow[tLocX])
end

on getTileNeighborInDirection me, tX, tY, tdir
 --PEEKFROMSTACK 0 if tdir  = 0 then -- jump 26
 --TRIMFROMSTACK 1 
return(me.getTile(tX, tY - 1))
 -- jump 252
end if -- jump 26 landing
 --PEEKFROMSTACK 0 
--nil--  = 1
if --nil-- then -- jump 29
 --TRIMFROMSTACK 1 
return(me.getTile(tX + 1, tY - 1))
 -- jump 218
end if -- jump 29 landing
 --PEEKFROMSTACK 0 
--nil--  = 2
if --nil-- then -- jump 26
 --TRIMFROMSTACK 1 
return(me.getTile(tX + 1, tY))
 -- jump 187
end if -- jump 26 landing
 --PEEKFROMSTACK 0 
--nil--  = 3
if --nil-- then -- jump 29
 --TRIMFROMSTACK 1 
return(me.getTile(tX + 1, tY + 1))
 -- jump 153
end if -- jump 29 landing
 --PEEKFROMSTACK 0 
--nil--  = 4
if --nil-- then -- jump 26
 --TRIMFROMSTACK 1 
return(me.getTile(tX, tY + 1))
 -- jump 122
end if -- jump 26 landing
 --PEEKFROMSTACK 0 
--nil--  = 5
if --nil-- then -- jump 29
 --TRIMFROMSTACK 1 
return(me.getTile(tX - 1, tY + 1))
 -- jump 88
end if -- jump 29 landing
 --PEEKFROMSTACK 0 
--nil--  = 6
if --nil-- then -- jump 26
 --TRIMFROMSTACK 1 
return(me.getTile(tX - 1, tY))
 -- jump 57
end if -- jump 26 landing
 --PEEKFROMSTACK 0 
--nil--  = 7
if --nil-- then -- jump 29
 --TRIMFROMSTACK 1 
return(me.getTile(tX - 1, tY - 1))
 -- jump 23
end if -- jump 29 landing
 --TRIMFROMSTACK 1 
return(error(me, "Invalid direction for tile:" && tdir, #getTileNeighborInDirection))
end if -- jump 23 landing
end if -- jump 57 landing
end if -- jump 88 landing
end if -- jump 122 landing
end if -- jump 153 landing
end if -- jump 187 landing
end if -- jump 218 landing
end if -- jump 252 landing
 --TRIMFROMSTACK 1 
end

on reserveTileForObject me, tLocX, tLocY, tObjectId, tObjectHeight
tTile = me.getTile(tLocX, tLocY)
if tTile  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if not listp(pTileSpaceReserveList[tObjectId]) then -- jump 15
pTileSpaceReserveList.setaProp(tObjectId, [])
end if -- jump 15 landing
pTileSpaceReserveList[tObjectId].append(tTile)
return(tTile.addContent(tObjectId, [#height: tObjectHeight]))
end

on clearObjectFromTileSpace me, tObjectId
if not listp(pTileSpaceReserveList[tObjectId]) then -- jump 9
return(1)
end if -- jump 9 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pTileSpaceReserveList[tObjectId]) <= 1 then -- jump 27 -- backjump 30 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tTile = --nil--
tTile.removeContent(tObjectId)
--nil-- + 1
 -- backjump 30
end if -- jump 27 landing
 --TRIMFROMSTACK 3 
pTileSpaceReserveList.setaProp(tObjectId, [])
return(1)
end

on getTileAtScreenCoordinate me, tLocX, tLocY
tRoomGeometry = me.getRoomGeometry()
if tRoomGeometry  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tloc = tRoomGeometry.getWorldCoordinate(tLocX, tLocY)
if tloc  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(me.getTile(tloc[1], tloc[2]))
end

on gettileatworldcoordinate me, tLocX, tLocY
tMultiplier = pTileWidth * pAccuracyFactor
if tLocX < -tMultiplier / 2 or tLocY < -tMultiplier / 2 then -- jump 8
return(0)
end if -- jump 8 landing
return(me.getTile(tLocX + tMultiplier / 2 / tMultiplier, tLocY + tMultiplier / 2 / tMultiplier))
end

on convertTileToWorldCoordinate me, tLocX, tLocY, tlocz
tMultiplier = pTileWidth * pAccuracyFactor
return([#x: tLocX * tMultiplier, #y: tLocY * tMultiplier, #h: tlocz * tMultiplier])
end

on convertTileToScreenCoordinate me, tLocX, tLocY, tlocz
tWorldCoordinate = me.convertTileToWorldCoordinate(tLocX, tLocY, tlocz)
return(me.convertWorldToScreenCoordinate(tWorldCoordinate.x, tWorldCoordinate.y, tWorldCoordinate.h))
end

on convertScreenToTileCoordinate me, tLocX, tLocY
tRoomGeometry = me.getRoomGeometry()
if tRoomGeometry  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tloc = tRoomGeometry.getWorldCoordinate(tLocX, tLocY)
if tloc  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return([#x: tloc[1], #y: tloc[2]])
end

on convertworldtotilecoordinate me, tLocX, tLocY
tMultiplier = pTileWidth * pAccuracyFactor
return([#x: tLocX + tMultiplier / 2 / tMultiplier, #y: tLocY + tMultiplier / 2 / tMultiplier])
end

on convertWorldToScreenCoordinate me, tX, tY, tZ
tRoomGeometry = me.getRoomGeometry()
if tRoomGeometry  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tMultiplier = float(pTileWidth * pAccuracyFactor)
tX = 0.5 + tX / tMultiplier
tY = -0.5 + tY / tMultiplier
tZ = tZ / tMultiplier
tloc = tRoomGeometry.getScreenCoordinate(tX, tY, tZ)
return(tloc)
end

on testForLineOfSightInTileMatrix me, tX1, tY1, tX2, tY2, tBlockingLevel, tExcludeFirst, tExcludeLast
tTester = me.getTileLineOfSight()
if tTester  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(tTester.testForLineOfSight(me, tX1, tY1, tX2, tY2, tBlockingLevel, tExcludeFirst, tExcludeLast))
end

on isBlockingLineOfSight me, tX, tY, tBlockingLevel
tTile = me.getTile(tX, tY)
if tTile  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(tTile.isBlockingLineOfSight(tBlockingLevel))
end

on getWorldReady me
return(pWorldReady)
end

on getGeometry me
return(pGeometry)
end

on getRoomGeometry me
if not objectp(pRoomGeometry) then -- jump 18
return(error(me, "Cannot locate room thread geometry object!", #getRoomGeometry))
end if -- jump 18 landing
return(pRoomGeometry)
end

on getTileLineOfSight me
if not objectp(pTileLineOfSight) then -- jump 18
pTileLineOfSight = createObject(#temp, getClassVariable("gamesystem.tilelineofsight.class"))
end if -- jump 18 landing
return(pTileLineOfSight)
end
