property pTurnManagerState, pDownloadMgrs, pSkillLevelChangeNoticeWindowID

on construct me
pSkillLevelChangeNoticeWindowID = "gamesys_skilllevel_announcement"
pTurnManagerState = 0
pDownloadMgrs = [:]
registerMessage(#roomReady, me.getID(), #checkIfInGameArea)
registerMessage(#leaveRoom, me.getID(), #leaveRoom)
registerMessage(#changeRoom, me.getID(), #leaveRoom)
registerMessage(#spectatorMode_on, me.getID(), #store_spectatorMode_on)
registerMessage(#spectatorMode_off, me.getID(), #store_spectatorMode_off)
return(1)
end

on deconstruct me
if windowExists(pSkillLevelChangeNoticeWindowID) then -- jump 11
removeWindow(pSkillLevelChangeNoticeWindowID)
end if -- jump 11 landing
me.stopTurnManager()
pDownloadMgrs = [:]
if memberExists("gsys_tournamentlogo") then -- jump 9
removeMember("gsys_tournamentlogo")
end if -- jump 9 landing
unregisterMessage(#roomReady, me.getID())
unregisterMessage(#leaveRoom, me.getID())
unregisterMessage(#changeRoom, me.getID())
unregisterMessage(#spectatorMode_on, me.getID())
unregisterMessage(#spectatorMode_off, me.getID())
return(1)
end

on defineClient me, tID
me.initVariables()
end

on leaveRoom me
me.stopTurnManager()
me.getMessageSender().setInstanceListUpdates(0)
me.initVariables()
return(1)
end

on initVariables me
tVarMgr = me.getVariableManager()
if tVarMgr  = 0 then -- jump 9
return(1)
end if -- jump 9 landing
tVarMgr.set(#game_status, #none)
tVarMgr.set(#game_location, [:])
tVarMgr.set(#instancelist, [:])
tVarMgr.set(#observed_instance_data, [:])
tVarMgr.set(#spectatormode_flag, 0)
tVarMgr.set(#tournament_flag, 0)
return(1)
end

on getGamestatus me
tVarMgr = me.getVariableManager()
if tVarMgr  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tVarMgr.exists(#game_status)  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(tVarMgr.GET(#game_status))
end

on startTurnManager me
return(me.getTurnManager().StartMinigameEngine())
end

on stopTurnManager me
return(me.getTurnManager().stopMinigameEngine())
end

on cancelCreateGame me
me.getVariableManager().set(#game_status, #none)
return(me.getMessageSender().setInstanceListUpdates(1))
end

on enterLounge me
if not getObject(#session).exists(#gamelounge_world_info) then -- jump 8
return(0)
end if -- jump 8 landing
tLoungeData = getObject(#session).GET(#gamelounge_world_info)
if not listp(tLoungeData) then -- jump 8
return(0)
end if -- jump 8 landing
executeMessage(#changeRoom)
return(me.spaceTravel(tLoungeData[#unitId], tLoungeData[#worldId], tLoungeData[#type]))
end

on checkIfInGameArea me
if not getObject(#session).exists("lastroom") then -- jump 8
return(0)
end if -- jump 8 landing
tRoomData = getObject(#session).GET("lastroom")
if not getObject(#session).exists(#gamespace_world_info) then -- jump 8
return(0)
end if -- jump 8 landing
tGameSpaceData = getObject(#session).GET(#gamespace_world_info)
if tRoomData[#port]  = tGameSpaceData[#unitId] and tRoomData[#door]  = tGameSpaceData[#worldId] then -- jump 12
return(1)
 -- jump 8
end if -- jump 12 landing
return(0)
end if -- jump 8 landing
end

on store_loungeinfo me, tdata
if tdata[#tournament_logo_url] <> void() then -- jump 103
me.getVariableManager().set(#tournament_flag, 1)
if memberExists("gsys_tournamentlogo") then -- jump 9
removeMember("gsys_tournamentlogo")
end if -- jump 9 landing
tAdMemNum = queueDownload(tdata[#tournament_logo_url], "gsys_tournamentlogo", #bitmap, 1, #httpcookie)
registerDownloadCallback(tAdMemNum, #store_tournamentlogo_member, me.getID(), [#member_num: tAdMemNum, #click_url: tdata[#tournament_logo_click_url]])
if tAdMemNum  = 0 then -- jump 13
error(me, "Gamesystem cannot initialize download manager!", #store_loungeinfo)
end if -- jump 13 landing
end if -- jump 103 landing
me.getVariableManager().set(#game_status, #none)
me.getMessageSender().setInstanceListUpdates(1)
if getObject(#session)  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tWorldData = getObject(#session).GET("lastroom")
if not listp(tWorldData) then -- jump 8
return(0)
end if -- jump 8 landing
getObject(#session).set(#gamelounge_world_info, [#unitId: tWorldData[#port], #worldId: tWorldData[#door], #type: tWorldData[#type]])
getObject(#session).Remove(#gamespace_world_info)
return(1)
end

on store_tournamentlogo_member me, tdata
me.getProcManager().distributeEvent(#tournamentlogo, tdata)
return(1)
end

on store_instancelist me, tList
if tList  = 0 then -- jump 8
tList = [:]
end if -- jump 8 landing
tVarMgr = me.getVariableManager()
if tVarMgr  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tVarMgr.set(#instancelist, tList)
tVarMgr.set(#instancelist_timestamp, the milliSeconds)
end

on store_gameinstance me, tItem
me.getMessageSender().setInstanceListUpdates(0)
me.getVariableManager().set(#observed_instance_data, tItem)
tInstanceList = me.getVariableManager().GET(#instancelist)
tInstanceList[string(tItem[#id])] = tItem
me.getVariableManager().set(#instancelist, tInstanceList)
if me.getGamestatus()  = #watch_requested then -- jump 33
me.getVariableManager().set(#game_status, #watch_confirmed)
return(me.getProcManager().distributeEvent(#watchok))
end if -- jump 33 landing
if me.getGamestatus()  = #join_requested then -- jump 33
me.getVariableManager().set(#game_status, #join_confirmed)
return(me.getProcManager().distributeEvent(#joinok))
end if -- jump 33 landing
if me.getGamestatus()  = #create_requested then -- jump 33
me.getVariableManager().set(#game_status, #create_confirmed)
return(me.getProcManager().distributeEvent(#createok))
end if -- jump 33 landing
return(1)
end

on store_gameparameters me, tParamList
me.getVariableManager().set(#gameparametervalues_format, tParamList)
end

on store_createfailed me, tReason
me.getVariableManager().set(#game_status, #none)
me.getMessageSender().setInstanceListUpdates(1)
end

on store_gamedeleted me, tInstanceId
tInstanceList = me.getVariableManager().GET(#instancelist)
tInstanceList.deleteProp(string(tInstanceId))
me.getVariableManager().set(#instancelist, tInstanceList)
me.getVariableManager().set(#observed_instance_data, [:])
me.getVariableManager().set(#game_status, #none)
me.getMessageSender().setInstanceListUpdates(1)
end

on store_joinparameters me, tParamList
me.getVariableManager().set(#joinparametervalues_format, tParamList)
end

on store_watchfailed me, tParamList
me.getVariableManager().set(#game_status, #observe_confirmed)
end

on store_gamelocation me, tParamList
executeMessage(#changeRoom)
tVarMgr = me.getVariableManager()
tVarMgr.set(#observed_instance_data, [:])
tVarMgr.set(#game_status, #game_waiting_for_start)
if getObject(#session)  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if me.getVariableManager().exists(#tournament_flag) then -- jump 26
tParamList.addProp(#tournament_flag, me.getVariableManager().GET(#tournament_flag))
 -- jump 12
end if -- jump 26 landing
tParamList.addProp(#tournament_flag, 0)
end if -- jump 12 landing
getObject(#session).set(#gamespace_world_info, tParamList)
me.getMessageSender().setInstanceListUpdates(0)
tUnitId = tParamList[#unitId]
tWorldId = tParamList[#worldId]
me.spaceTravel(tUnitId, tWorldId, #game)
end

on store_gamestatus me, tdata
if not listp(tdata) then -- jump 8
return(0)
end if -- jump 8 landing
tCount = tdata.count
i = 1
if i <= tCount then -- jump 48 -- backjump 51 landing
tElementId = tdata.getPropAt(i)
me.getProcManager().distributeEvent(tdata.getPropAt(i), tdata[i])
i = 1 + i
 -- backjump 51
end if -- jump 48 landing
return(1)
end

on store_gamestatus_turn me, tdata
if not objectp(tdata) then -- jump 8
return(0)
end if -- jump 8 landing
return(me.getTurnManager().addTurnToBuffer(tdata))
end

on store_gamestart me, tdata
executeMessage(#game_started)
return(me.getVariableManager().set(#game_status, #game_started))
end

on store_gameend me, tdata
executeMessage(#game_end)
return(me.getVariableManager().set(#game_status, #game_waiting_for_restart))
end

on store_gamereset me, tdata
executeMessage(#game_reset)
return(me.getVariableManager().set(#game_status, #game_waiting_for_start))
end

on store_spectatorMode_on me
return(me.getVariableManager().set(#spectatormode_flag, 1))
end

on store_spectatorMode_off me
return(me.getVariableManager().set(#spectatormode_flag, 0))
end

on store_skilllevelchanged me, tProps
if not listp(tProps) then -- jump 8
return(0)
end if -- jump 8 landing
tLevelName = tProps[#level]
createWindow(pSkillLevelChangeNoticeWindowID, "habbo_simple.window")
tWndObj = getWindow(pSkillLevelChangeNoticeWindowID)
if tWndObj  = 0 then -- jump 18
return(error(me, "Cannot create window", #store_skilllevelchanged))
end if -- jump 18 landing
if not tWndObj.merge("habbo_games_levelup.window") then -- jump 14
return(tWndObj.close())
end if -- jump 14 landing
tElem = tWndObj.getElement("habbo_games_levelup_a")
if tElem <> 0 then -- jump 17
tElem.setText(getText("gs_skill_changed_header"))
end if -- jump 17 landing
tElem = tWndObj.getElement("habbo_games_levelup_b")
if tElem <> 0 then -- jump 26
tElem.setText(replaceChunks(getText("gs_skill_changed"), "%1", tLevelName))
end if -- jump 26 landing
tWndObj.registerProcedure(#eventProcSkillChange, me.getID(), #mouseUp)
return(1)
end

on eventProcSkillChange me, tSprID, tPar1, tPar2
return(removeWindow(pSkillLevelChangeNoticeWindowID))
end

on spaceTravel me, tUnitId, tWorldId, tWorldType
me.getMessageSender().setInstanceListUpdates(0)
tPresentStruct = getObject(#session).GET("lastroom")
if tPresentStruct  = 0 then -- jump 17
tPresentStruct = [#name: tWorldId, #casts: []]
end if -- jump 17 landing
tStruct = [:]
tStruct.setaProp(#id, tPresentStruct[#id])
tStruct.setaProp(#name, tPresentStruct[#name])
tStruct.setaProp(#type, tWorldType)
tStruct.setaProp(#owner, 0)
tStruct.setaProp(#teleport, 0)
tStruct.setaProp(#door, tWorldId)
tStruct.setaProp(#port, tUnitId)
tStruct.setaProp(#casts, tPresentStruct[#casts])
executeMessage(#enterRoomDirect, tStruct)
return(1)
end
