property pWaitingForSync, pWaitingForSyncCounter, pWaitingForSyncThreshold, pTurnContainerClass, pTurnContainerPool, m_iAllocationModel, m_rObjectPool, m_sHandler, m_rHandler, m_rQuickRandom, m_rCurrentTurn, m_rNextTurn, m_fTurnT, m_fTurnPulse, m_ar_turnBuffer, m_syncLostTime, m_iSpeedUp, m_iLastMS, m_iLastSubTurn, m_iSubTurnSpacing, m_aLastTurnData, m_bDump

on construct me
pWaitingForSync = 0
pWaitingForSyncCounter = 0
pWaitingForSyncThreshold = 90
pTurnContainerClass = getClassVariable("gamesystem.turn.class")
pTurnContainerPool = []
m_iAllocationModel = #pool
m_rHandler = void()
m_sHandler = ["CMinigameHandlerPrototype"]
m_rCurrentTurn = void()
m_rNextTurn = void()
m_fTurnT = 0.0
m_fTurnPulse = 0.3
m_iLastMS = 0
m_iLastSubTurn = 0
m_ar_turnBuffer = []
m_syncLostTime = 0.0
m_iSpeedUp = 1
m_iSubTurnSpacing = 100.0
m_aLastTurnData = [:]
m_bDump = 0
createObject("MGEQuickRandom", "CIterateSeed")
m_rQuickRandom = getObject("MGEQuickRandom")
registerMessage(#SetMinigameHandler, me.getID(), #_SetMinigameHandler)
return(1)
end

on deconstruct me
m_rCurrentTurn = void()
pTurnContainerPool = []
m_ar_turnBuffer = []
if not voidp(m_rHandler) then -- jump 14
removeObject(m_rHandler.getID())
end if -- jump 14 landing
removeObject(m_rQuickRandom.getID())
unregisterMessage(#SetMinigameHandler, me.getID())
removeUpdate(me.getID())
return(1)
end

on StartMinigameEngine me
pWaitingForSync = 0
pWaitingForSyncCounter = 0
m_fTurnT = 0.0
m_iLastMS = the milliSeconds
m_iLastSubTurn = -1
me._ClearCurrentTurn()
me._ClearTurnBuffer()
receiveUpdate(me.getID())
end

on stopMinigameEngine me
me._ClearTurnBuffer()
pTurnContainerPool = []
m_fTurnT = 0.0
m_iLastMS = the milliSeconds
m_iLastSubTurn = -1
m_aLastTurnData = [:]
pWaitingForSync = 1
end

on getNewTurnContainer me
if pTurnContainerPool.count > 0 and m_iAllocationModel <> #simple then -- jump 33
tTurnObject = pTurnContainerPool[1]
pTurnContainerPool.deleteAt(1)
return(tTurnObject)
 -- jump 16
end if -- jump 33 landing
return(createObject(#temp, pTurnContainerClass))
end if -- jump 16 landing
end

on releaseTurnContainer me, tObject
if tObject  = 0 then -- jump 9
return(1)
end if -- jump 9 landing
if m_iAllocationModel  = #simple then -- jump 9
return(1)
end if -- jump 9 landing
tObject.construct()
pTurnContainerPool.add(tObject)
return(1)
end

on _SetMinigameHandler me, i_sClass
m_sHandler = i_sClass
createObject("MGEHandler", "CMinigameHandlerPrototype", m_sHandler)
m_rHandler = getObject("MGEHandler")
end

on GetQuickRandom me
return(m_rQuickRandom)
end

on GetTurnNumber me
return(m_rCurrentTurn.GetNumber())
end

on GetSubturnSpacing me
return(m_iSubTurnSpacing)
end

on _TurnBufferState me
if m_ar_turnBuffer.count > 1 then -- jump 10
return(#overfill)
end if -- jump 10 landing
if m_ar_turnBuffer.count  = 1 then -- jump 10
return(#ready)
end if -- jump 10 landing
if m_ar_turnBuffer.count  = 0 then -- jump 10
return(#empty)
end if -- jump 10 landing
end

on _AdvanceTurn me
me._ClearCurrentTurn()
if pWaitingForSync then -- jump 46
pWaitingForSyncCounter = pWaitingForSyncCounter + 1
if pWaitingForSyncCounter < pWaitingForSyncThreshold then -- jump 8
return(0)
end if -- jump 8 landing
pWaitingForSyncCounter = 0
return(me.getMessageSender().sendRequestFullStatusUpdate())
end if -- jump 46 landing
 --PEEKFROMSTACK 0 if me._TurnBufferState() <> #ready then -- jump 12
 --PEEKFROMSTACK 0 
--nil--  = #overfill
if --nil-- then -- jump 36
end if -- jump 12 landing
m_rCurrentTurn = m_ar_turnBuffer[1]
m_ar_turnBuffer.deleteAt(1)
m_fTurnT = 0.0
 -- jump 37
end if -- jump 36 landing
 --PEEKFROMSTACK 0 
--nil--  = #empty
if --nil-- then -- jump 28
m_iSpeedUp = 1
m_rCurrentTurn = void()
if m_bDump then -- jump 10
put("MGEngine: No turns in buffer. Speedup off")
end if -- jump 10 landing
end if -- jump 28 landing
end if -- jump 37 landing
 --TRIMFROMSTACK 1 
m_iLastSubTurn = 0
m_fTurnT = 0.0
end

on addTurnToBuffer me, i_rTurn
if pWaitingForSync then -- jump 8
return(0)
end if -- jump 8 landing
if voidp(m_rCurrentTurn) then -- jump 39
if m_bDump then -- jump 20
put("MGEngine: Turn sync gained after" && m_syncLostTime && "seconds.")
 -- jump 16
end if -- jump 20 landing
if m_bDump then -- jump 10
put("MGEngine: Extra turn in buffer")
end if -- jump 10 landing
end if -- jump 16 landing
end if -- jump 39 landing
m_ar_turnBuffer.append(i_rTurn)
end

on _ClearTurnBuffer me
me._ClearCurrentTurn()
m_ar_turnBuffer = []
end

on _ClearCurrentTurn me
if voidp(m_rCurrentTurn) then -- jump 9
return(1)
end if -- jump 9 landing
if m_iAllocationModel <> #simple then -- jump 13
me.releaseTurnContainer(m_rCurrentTurn)
end if -- jump 13 landing
m_rCurrentTurn = void()
end

on floor i_fVal
tInteger = integer(i_fVal)
if tInteger > i_fVal then -- jump 20
return(float(tInteger - 1))
 -- jump 14
end if -- jump 20 landing
return(float(tInteger))
end if -- jump 14 landing
end

on ProcessSubTurn me, i_iSubturn
if i_iSubturn <= m_rCurrentTurn.GetNSubTurns() then -- jump 131
t_ar_events = m_rCurrentTurn.GetSubTurn(i_iSubturn)
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(t_ar_events) <= 1 then -- jump 99 -- backjump 102 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tEvent = --nil--
t_iEvent = tEvent.getProp(#event_type)
t_ar_iData = []
if tEvent.count > 1 then -- jump 45
tCount = tEvent.count
i = 2
if i <= tCount then -- jump 27 -- backjump 30 landing
t_ar_iData.append(tEvent[i])
i = 1 + i
 -- backjump 30
end if -- jump 27 landing
end if -- jump 45 landing
m_rHandler.OnEvent(t_iEvent, tEvent)
--nil-- + 1
 -- backjump 102
end if -- jump 99 landing
 --TRIMFROMSTACK 3 
end if -- jump 131 landing
me.getComponent().executeSubturnMoves(m_rCurrentTurn.GetNumber(), i_iSubturn)
end

on update me
tTime = the milliSeconds
dT = tTime - m_iLastMS / 1000.0
m_iLastMS = tTime
if not voidp(m_rCurrentTurn) then -- jump 309
if not m_rCurrentTurn.GetTested() then -- jump 18
me._MinigameTestChecksum(m_rCurrentTurn.GetCheckSum())
end if -- jump 18 landing
m_syncLostTime = 0.0
if me._TurnBufferState()  = #overfill then -- jump 30
m_iSpeedUp = m_ar_turnBuffer.count / 1.5
if m_bDump then -- jump 10
put("MGEngine: speedup on")
end if -- jump 10 landing
end if -- jump 30 landing
m_fTurnT = m_fTurnT + dT
if m_rCurrentTurn  = void() then -- jump 9
return(1)
end if -- jump 9 landing
tSubturnSpacing = m_fTurnPulse / m_rCurrentTurn.GetNSubTurns()
m_iSubTurnSpacing = tSubturnSpacing * 1.0 / m_iSpeedUp
tSubturnSpacing = m_iSubTurnSpacing
tSubturn = integer(floor(m_fTurnT / tSubturnSpacing)) + 1
if tSubturn > m_rCurrentTurn.GetNSubTurns() then -- jump 13
tSubturn = m_rCurrentTurn.GetNSubTurns()
end if -- jump 13 landing
if m_bDump then -- jump 22
put("SubTurnSpacing :" && tSubturnSpacing && "ms, buffer size :" && m_ar_turnBuffer.count)
end if -- jump 22 landing
if tSubturn <> m_iLastSubTurn then -- jump 92
if tSubturn - 1 <> m_iLastSubTurn then -- jump 50
tMissedCount = tSubturn - 1 - m_iLastSubTurn
missedTurn = tSubturn - tMissedCount
if missedTurn <= tSubturn - 1 then -- jump 21 -- backjump 27 landing
me.ProcessSubTurn(missedTurn)
missedTurn = 1 + missedTurn
 -- backjump 27
end if -- jump 21 landing
end if -- jump 50 landing
if m_bDump then -- jump 13
put("SubTurnN :" & tSubturn)
end if -- jump 13 landing
me.ProcessSubTurn(tSubturn)
m_iLastSubTurn = tSubturn
end if -- jump 92 landing
 -- jump 12
end if -- jump 309 landing
m_syncLostTime = m_syncLostTime + dT
end if -- jump 12 landing
tFrameRateEnough = 1
if dT > m_fTurnPulse then -- jump 19
if m_bDump then -- jump 10
put("MGEngine: frame rate too slow!!!")
end if -- jump 10 landing
tFrameRateEnough = 0
end if -- jump 19 landing
if me.turnDone() or not tFrameRateEnough then -- jump 173
if not voidp(m_rCurrentTurn) then -- jump 78
if tSubturn < m_rCurrentTurn.GetNSubTurns() then -- jump 64
tTurnsToDo = m_rCurrentTurn.GetNSubTurns() - tSubturn
missedTurn = m_rCurrentTurn.GetNSubTurns() - tTurnsToDo + 1
if missedTurn <= m_rCurrentTurn.GetNSubTurns() then -- jump 21 -- backjump 30 landing
me.ProcessSubTurn(missedTurn)
missedTurn = 1 + missedTurn
 -- backjump 30
end if -- jump 21 landing
end if -- jump 64 landing
end if -- jump 78 landing
if not tFrameRateEnough then -- jump 73
t = 1
if t <= m_ar_turnBuffer.count - 1 then -- jump 55 -- backjump 64 landing
me._AdvanceTurn()
tSubturn = 1
if tSubturn <= m_rCurrentTurn.GetNSubTurns() then -- jump 21 -- backjump 30 landing
me.ProcessSubTurn(tSubturn)
tSubturn = 1 + tSubturn
 -- backjump 30
end if -- jump 21 landing
t = 1 + t
 -- backjump 64
end if -- jump 55 landing
end if -- jump 73 landing
me._AdvanceTurn()
end if -- jump 173 landing
end

on turnDone me
tPulse = m_fTurnPulse * 1.0 / m_iSpeedUp
return(m_fTurnT >= tPulse or voidp(m_rCurrentTurn))
end

on _MinigameTestChecksum me, i_iChecksum
tMyChecksum = me.calculateChecksum()
m_rCurrentTurn.SetTested(1)
if i_iChecksum <> tMyChecksum then -- jump 90
put("*** TURN" && m_rCurrentTurn.GetNumber() && " - CHECKSUM MISMATCH! server says:" && i_iChecksum & ", we say:" && tMyChecksum && ". Previous turn:" && m_aLastTurnData)
put("Turn was " & m_syncLostTime & " seconds late.")
put(me.getComponent().dumpChecksumValues())
me._ClearTurnBuffer()
me.getMessageSender().sendRequestFullStatusUpdate()
pWaitingForSync = 1
end if -- jump 90 landing
if m_rCurrentTurn <> void() then -- jump 37
m_aLastTurnData.setaProp("Turn", m_rCurrentTurn.GetNumber())
m_aLastTurnData.setaProp("Events", m_rCurrentTurn.GetSubTurns())
end if -- jump 37 landing
end

on calculateChecksum me
if not voidp(m_rCurrentTurn) then -- jump 42
tCheckSum = m_rQuickRandom.IterateSeed(m_rCurrentTurn.GetNumber())
tCheckSum = me.getComponent().calculateChecksum(tCheckSum)
return(tCheckSum)
end if -- jump 42 landing
end
